/* Problem URL: https://codeforces.com/contest/2060/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

void dothething(int i, V<bool> &vis, vi &groups, int group, vvi &graph)
{
    vis[i] = true;
    groups[i] = group;

    repv(c, graph[i]) {
        if (vis[c]) {
            continue;
        }

        dothething(c, vis, groups, group, graph);
    }
}

int get(int i, V<bool> &vis, vi &groups, vvi &graph)
{
    vis[i] = true;

    int invalid = 0;
    repv(c, graph[i]) {
        if (vis[c]) {
            continue;
        }

        if (groups[i] != groups[c]) {
            invalid++;
            continue;
        }

        invalid += get(c, vis, groups, graph);
    }

    return invalid;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;

        vvi f(n);
        rep(i, m1) {
            int a, b;
            cin >> a >> b;
            a--, b--;
            f[a].push_back(b);
            f[b].push_back(a);
        }

        vvi g(n);
        rep(i, m2) {
            int a, b;
            cin >> a >> b;
            a--, b--;
            g[a].push_back(b);
            g[b].push_back(a);
        }

        V<bool> vis(n, false);
        int group = 0;
        vi groups(n, -1);
        rep(i, n) {
            if (!vis[i]) {
                dothething(i, vis, groups, group, g);
                group++;
            }
        }

        vis.assign(n, false);
        int count = 0;
        int invalid = 0;
        rep(i, n) {
            if (!vis[i]) {
                invalid += get(i, vis, groups, f);
                count++;
            }
        }

        cout << invalid + (count - group) << '\n';
    }
}
